<?php

/**
 * inf_radicado actions.
 *
 * @package    cobro_coactivo
 * @subpackage inf_radicado
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_radicadoActions extends sfQuery {

    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    // Cambiar nombre executeList2 a executeList si se quiere volver a usar esta función. 
    public function executeList2(sfWebRequest $request) {
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejar Errores
         */
        try {

            /*
             * Variables para el registro de log
             */

            //1 - indica operacion de consulta
            $id_ope_bd = 1;

            //obtener id maestro tabla
            $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_debito_ref');


            //CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, $observacion);

            /*
             * Filtro para que levante por CO_ESTUDIOS_PREVIOS y por FASE
             */

            $where = "";
            $whereTituloMinero = "";
            $whereAbogado = "";
            $wherePar = "";

            if (isset($request['id_par'])) {
                $wherePar = " AND tab0.id_par=" . $request['id_par'];
            }

            if (isset($request['cod_titulo'])) {
                $whereTituloMinero.=" AND tab0.cod_titulo='" . $request['cod_titulo'] . "'";
            }

            //$id_anhos = $request['id_anhos'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            /*
             * Obtiene las vigencias/periodo que se encuentre en la tabla de saldos
             */
            $sql = <<<EOD
    select tab0.*
    from(
        select 
            tab0.numero_remision,
            tab0.numero_correpondencia,
            tab0.anho_remision, 
            tab0.fecha_remision,
            tab0.id_par,
            tab0.cod_titulo,
            v0.MINERAL,
            tab0.no_folios,
            tab1.descripcion AS PAR,
            tab0.cod_titulo AS TITULO,
            tab0.estado

        from cbr_remision_titulo tab0
        left join cbr_par tab1 ON tab1.id_par = tab0.id_par
        left join cbr_titulo_minero_v v0  ON v0.COD_TITULO = tab0.cod_titulo
    )tab0

    where tab0.fecha_remision BETWEEN 
        TO_DATE('$fecha_ini', 'YYYY-MM-DD') AND 
        TO_DATE('$fecha_fin', 'YYYY-MM-DD')
    $wherePar $whereTituloMinero                  
    ORDER BY tab0.par, tab0.numero_remision, tab0.numero_correpondencia

EOD;
            $records = CN_TABLE::executeSQL($sql);

            //Ejecuta sql
            $this->totalRows = count($records);
            $this->list_data = $records;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /*
     * Se deja de usar la función executeList de arriba y se extiende esta clase del manejador de consultas sfQuery
     * Oscar Acero - 19092016  
     */

    /*
     * ------VARIABLES PARA SERVICIOS DE CONSULTA - LIST ---------------
     */

    protected $table_names = array(
        'CBR_REMISION_TITULO',
        'CBR_PAR',
        'CBR_TITULO_MINERO_V',
        'CBR_ABOGADO_ULT_V'
    ); //Tablas necesarias para construir la cosnulta sql.
    protected $table_join_ids = array(
        'CBR_PAR' =>
        array(
            'id_par' => 'CBR_REMISION_TITULO'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ABOGADO_ULT_V,LEFT'=>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        )
    ); //Identificadores de los campos que se usaran para declarar los joins.
    protected $fields = array(
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'numero_correpondencia' => 'numero_correpondencia',
            'fecha_remision' => 'fecha_remision',
            'id_par' => 'id_par',
            'no_folios' => 'no_folios',
            'estado' => 'estado',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral',
        ),
        'CBR_PAR' =>
        array(
            'descripcion' => 'par'
        ),
        'CBR_ABOGADO_ULT_V'=>
        array(
            'id_abogado'=>'id_abogado',
            'num_doc'=>'num_doc',
            'razon_soc'=>'razon_soc'
        )
    ); //Campos que retornará la consulta
    protected $fields_orderBy = array(
        'cod_titulo', 'fecha_remision'
    ); //Criterio para ordenar los registros arrojados por la consulta

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo,a' => array('!=' => array(-1)),
            'id_remision_titulo,b' => array('=' => array('id_remision_titulo')),
            'id_par' => array('=' => array('id_par')),
            'cod_titulo' => array('=' => array('cod_titulo')),
            'estado' => array('=' => array('estado')),
            'numero_remision' => array('=' => array('numero_remision')),
            //'anho_remision' => array('=' => array('anho_remision')),
            'numero_correpondencia' => array('=' => array('numero_correpondencia')),
            //'no_folios' => array('=' => array('no_folios')),
            'fecha_remision' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_ABOGADO_ULT_V'=>
        array(
            'id_abogado' => array('=' => array('id_abogado')),
            'num_doc' => array('=' => array('num_doc'))
        )
    ); // Condiciones para filtrar registros arrojados por la consulta
    protected $table_field_or_conditions = array(
    ); //
    protected $is_admin = true;
    protected $is_filtro = true;

    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_remision_titulo'; //identificador de la tabla
    protected $id_names = array('id_remision_titulo'); //llave primaria
    protected $field_names = array('numero_remision', 'anho_remision', 'numero_correpondencia',
        'fecha_remision', 'id_par', 'no_folios', 'estado', 'cod_titulo'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_REMISION_TITULO'; //tabla en la cual se aplican los cambios 

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_remision_titulo'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Reemplazar espacios en blanco - 20160217
            $request['cod_titulo'] = str_replace(' ', '', $request['cod_titulo']);

            $fecha_remision = $request['fecha_remision'];

            $sql = <<<EOD
select to_char(to_date('$fecha_remision','YYYY-MM-DD'),'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];

            $request['anho_remision'] = $id_anhos;

            $sql = <<<EOD
select consecutivo from cbr_consecutivo_remis where id_anhos = $id_anhos
EOD;


            $records = CN_TABLE::executeSQL($sql);

            $consecutivo = $records[0]['consecutivo'];

            $request['numero_remision'] = $consecutivo;

            $sql = <<<EOD
update cbr_consecutivo_remis set consecutivo =($consecutivo+1) where id_anhos = $id_anhos
EOD;

            CN_TABLE::executeSQL($sql);
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        $error = null;
        return $error;
    }

    protected function validateRemove(\sfWebRequest $request) {
        $error = null;
        return $error;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        $error = null;
        return $error;
    }

}
